;**************************************************************
;*	CFU 5 Rahmen
;*  Nach einer Idee von Bertholdsw
;*  Erstellt bis zu fünf Rahmen
;*	Geschrieben für GIMP 2.6
;*
;*	Einstellbare Parameter:
;*	"Rahmenbreite"                       
;*	"Rahmenfarbe"  
;*  "Zufallsrahmen"                   
;*	"Sichtbare Ebenen zusammenfassen"                                             
;*
;*	V1.0 vom "10.03.2012"  
;*	V1.1 vom "19.05.2012"  
;*    Der Rahmen steht als obersate Ebene 
;*    zur weiteren Verarbeitung zur Verfügung
;*
;**************************************************************


(define (script-fu-cf-rahmen-5-rahmen-v11 inBild inEbene inR1 inC1 inR2 inC2 inR3 inC3 inR4 inC4 inR5 inC5 inZufall inZusammen )

	(let* (	
        (bgcolorOrg (car(gimp-palette-get-background)))
        (new_ebene (car (gimp-layer-copy (car (gimp-image-get-active-layer inBild)) FALSE)))
        (layers (gimp-image-get-layers inBild))
        (num-layers (car layers))
        (layer-array (cadr layers))
        (i num-layers)
        (pAnz 5)
        (pR1 inR1)
        (pC1 inC1)
        (pR2 inR2)
        (pC2 inC2)
        (pR3 inR3)
        (pC3 inC3)
        (pR4 inR4)
        (pC4 inC4)
        (pR5 inR5)
        (pC5 inC5)
        (BB (car (gimp-image-width  inBild)))
        (BH (car (gimp-image-height inBild)))
        (modus (modulo (random 999) 4))
        (save-selection-1 0)
        (save-selection-2 0)
        (layer0 0)
		)

(define (script-fu-cf-rand-5r-v11 iBild iEbene iR iC)
  (let*   (
            (BildBreite (car (gimp-image-width  iBild)))
            (BildHoehe  (car (gimp-image-height iBild)))
            (new_breit  (+ BildBreite (* 2 iR)))
            (new_hoch   (+ BildHoehe  (* 2 iR)))
          )
						(gimp-palette-set-background iC)	
						(gimp-image-resize iBild new_breit new_hoch iR iR)
						(gimp-layer-resize-to-image-size iEbene)
  )
)

;        (if (= (modulo (random 999) 2) 0)
;          (set! pC1 (list (random 64) (random 64) (random 64)))
;          (set! pC1 (car (gimp-image-pick-color inBild inEbene (random BB) (random BH) TRUE TRUE (+ (random 10)1))))
;        )

(define (script-fu-cf-neue-farbe iFarbeAlt ifBild ifEbene ifBB ifBH inModus1 inModus2)
  (let*   (
            (Farbeneu iFarbeAlt)
            (mod1 (- inModus1 1))
            (mod2 inModus2)
          )
          
          (if (= mod1 1)
            (set! mod1 (- mod1 (modulo (random 999) 2)))
          )
          
          (if (= mod1 0)
            (begin
              (cond ((= mod2 0)
                (set! Farbeneu (list (random 64)  (random 64)  (random 64) )))
                    ((= mod2 1)
                (set! Farbeneu (list (random 128) (random 128) (random 128))))
                    ((= mod2 2)
                (set! Farbeneu (list (random 192) (random 192) (random 192))))
                    ((= mod2 3)
                (set! Farbeneu (list (random 255) (random 255) (random 255))))
              )
            )
            (begin
              (set! Farbeneu (car (gimp-image-pick-color ifBild ifEbene (random ifBB) (random ifBH) TRUE TRUE (+ (random 10)1))))
            )
          )

          Farbeneu
  )
)
    
    
		(gimp-undo-push-group-start inBild)
    
		(gimp-image-add-layer inBild new_ebene 1)
    (gimp-layer-flatten new_ebene)
    (gimp-image-lower-layer-to-bottom inBild new_ebene)
		(gimp-palette-set-background '(255 255 255))
		(gimp-drawable-fill new_ebene BACKGROUND-FILL)
		(gimp-layer-set-name new_ebene "CF 5 Rahmen")
    (set! save-selection-1 (car(gimp-selection-save inBild)))
    (gimp-selection-all inBild)
    
    (if (> inZufall 0)
      ( begin
        (set! pR1 (random 10))
        (set! pR2 (random 50))
        (set! pR3 (random 10))
        (set! pR4 (random 50))
        (set! pR5 (random 10))
        
        (set! pC1 (script-fu-cf-neue-farbe pC1 inBild inEbene BB BH inZufall modus))
        (set! pC2 (script-fu-cf-neue-farbe pC2 inBild inEbene BB BH inZufall modus))
        (set! pC3 (script-fu-cf-neue-farbe pC3 inBild inEbene BB BH inZufall modus))
        (set! pC4 (script-fu-cf-neue-farbe pC4 inBild inEbene BB BH inZufall modus))
        (set! pC5 (script-fu-cf-neue-farbe pC5 inBild inEbene BB BH inZufall modus))
 
        (set! pAnz (+ (random 5) 1))
      )
    )

    (if (and (> pR1 0) (>= pAnz 1))
      (script-fu-cf-rand-5r-v11 inBild new_ebene pR1 pC1)
    )
    (if (and (> pR2 0) (>= pAnz 2))
      (script-fu-cf-rand-5r-v11 inBild new_ebene pR2 pC2)
    )
    (if (and (> pR3 0) (>= pAnz 3))
      (script-fu-cf-rand-5r-v11 inBild new_ebene pR3 pC3)
    )
    (if (and (> pR4 0) (>= pAnz 4))
      (script-fu-cf-rand-5r-v11 inBild new_ebene pR4 pC4)
    )
    (if (and (> pR5 0) (>= pAnz 5))
      (script-fu-cf-rand-5r-v11 inBild new_ebene pR5 pC5)
    )

    (gimp-image-raise-layer-to-top inBild new_ebene)
    (gimp-layer-add-alpha new_ebene)
    (gimp-edit-clear new_ebene)
		(gimp-palette-set-background bgcolorOrg)
    (gimp-layer-set-visible new_ebene TRUE)
    
    (cond ((= inZusammen 0)
                (set! inEbene (car (gimp-image-merge-visible-layers inBild  EXPAND-AS-NECESSARY))))
          ((= inZusammen 2)
                (begin
                  (while (> i 0)
                    (begin 	  	    
                      (set! i (- i 1))    
                      (gimp-layer-resize-to-image-size (vector-ref layer-array i))     
                    )
                  )
                ))
    )

    (gimp-image-set-active-layer inBild inEbene)
    (gimp-selection-load save-selection-1)
		(gimp-displays-flush)
		(gimp-undo-push-group-end inBild)

 	);let
) ;;def

 
	(script-fu-register
		"script-fu-cf-rahmen-5-rahmen-v11"            ;Name der Funktion, die aufgerufen werden soll
		"CFU 5 Rahmen V1.1"                            ;Name des Skripts
		"Erstellt bis zu 5 farbige Ränder"    		;Beschreibung des Skripts
		"CF"                                     	;Name des Autors
		"Copyleft by CF"                         	;Copyright-Infos
		"10.03.2012"                             	;Datum
		"RGB* GRAY* INDEXED*"                     ;
		SF-IMAGE "Das Bild" 0
		SF-DRAWABLE "Die Ebene" 0
    SF-ADJUSTMENT "Rahmenbreite 1"     						'(1 0 1000 1 10 0 0)
 		SF-COLOR "Rahmenfarbe 1" '(0 0 0)
    SF-ADJUSTMENT "Rahmenbreite 2"     						'(6 0 1000 1 10 0 0)
 		SF-COLOR "Rahmenfarbe 2" '(32 88 23)
    SF-ADJUSTMENT "Rahmenbreite 3"     						'(2 0 1000 1 10 0 0)
 		SF-COLOR "Rahmenfarbe 3" '(0 0 0 )
    SF-ADJUSTMENT "Rahmenbreite 4"     						'(6 0 1000 1 10 0 0)
 		SF-COLOR "Rahmenfarbe 4" '(88 23 78)
    SF-ADJUSTMENT "Rahmenbreite 5"     						'(1 0 1000 1 10 0 0)
 		SF-COLOR "Rahmenfarbe 5" '(0 0 0)
		SF-OPTION "Zufallsrahmen" '("Nein" "Mit beliebigen Farben" "Mit gemischten Farben" "Mit Farben aus der aktiven Ebene") 
		SF-OPTION "Ebenen" '("Sichtbare Zusammenfassen" "Belassen" "Auf Bildgröße Bringen") 
;		SF-TOGGLE "Sichtbare Ebenen zusammenfassen" TRUE
	)

	(script-fu-menu-register "script-fu-cf-rahmen-5-rahmen-v11" "<Image>/CFU/Rahmen")		
